; $Header: svn+ssh://source.omnigroup.com/Source/svn/Omni/trunk/Staff/kc/Scripts/omnifocus-capture.el 112386 2009-05-06 05:45:33Z kc $
;
; To capture tasks from Emacs to OmniFocus using Control-C Control-O,
; drop this script in your emacs load path and add lines like these to
; your .emacs:
;
; (autoload 'send-region-to-omnifocus "omnifocus-capture" "Send region to OmniFocus" t)
; (global-set-key "\C-c\C-o" 'send-region-to-omnifocus)


(defun applescript-quote-string (argument)
  "Quote a string for passing as a string to AppleScript."
    (if (equal argument "")
        "\"\""
      ;; Quote using double quotes, but escape any existing quotes or
      ;; backslashes in the argument with backslashes.
      (let ((result "")
	    (start 0)
	    end)
	(if (or (null (string-match "[^\"\\]" argument))
		(< (match-end 0) (length argument)))
	    (while (string-match "[\"\\]" argument start)
	      (setq end (match-beginning 0)
		    result (concat result (substring argument start end)
				   "\\" (substring argument end (1+ end)))
		    start (1+ end))))
	(concat "\"" result (substring argument start) "\""))))

(defun send-region-to-omnifocus (beg end)
  "Send the selected region to OmniFocus"
  (interactive "r")
  (let ((script-file (make-temp-file (expand-file-name "send-region-to-omnifocus" temporary-file-directory) nil ".applescript"))
	(captured-text (buffer-substring beg end)))
    (save-excursion
      (set-buffer (get-buffer-create "*OmniFocus*"))
      (insert (format "
	tell application \"OmniFocus\" to tell quick entry
		activate
			tell make new inbox task with properties {note:%s}
				try
					set MySummary to (summarize note as rich text)
				on error e
					set MySummary to missing value
				end try
				if MySummary is \"\" or MySummary is missing value then
					set MySummary to \"Task from Emacs\"
				end if
				set name to MySummary
			end tell
		end tell" (applescript-quote-string captured-text)))
      (write-file script-file)
      (shell-command (format "osascript %s" (shell-quote-argument script-file)))
      (delete-file script-file)
      )))
